<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>components - Basic - Register - Props</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>

<body>
    <div id="components-demo">
        <button-counter></button-counter>
        <button-counter></button-counter>
        <button-counter></button-counter>
    </div>
    <script>
        Vue.component('button-counter', {
            data: function () {
                return {
                    count: 0
                }
            },
            template: '<button v-on:click="count++">Bạn đã bấm {{ count }} lần.</button>'
        })
        new Vue({ el: '#components-demo' })
    </script>
    <br>
    <!-- demo blog -->
    <div id="blog-post-demo">
        <blog-post v-for="post in posts" v-bind:key="post.id" v-bind:title="post.title"></blog-post>
    </div>
    <script>
        Vue.component('blog-post', {
            props: ['title'],
            template: '<h3>{{ title }}</h3>'
        })
        new Vue({
            el: '#blog-post-demo',
            data: {
                posts: [
                    { id: 1, title: 'Giới thiệu về Vue' },
                    { id: 2, title: 'Các khái niệm trong Vue' },
                    { id: 3, title: 'Vue căn bản và vô cùng nâng cao' }
                ]
            }
        })
    </script>
    <br>
    <!-- template  -->
    <div id="blog-posts-events-demo">
        <div :style="{ fontSize: postFontSize + 'em' }">
            <blog-post v-for="post in posts" v-bind:key="post.id" v-bind:post="post"></blog-post>
        </div>
    </div>
    <script>
        Vue.component('blog-post', {
            props: ['post'],
            template: '<div class="blog-post"><h3>{{ post.title }}</h3><button >Phóng to</button><div v-html="post.content"></div></div>'
        })
        new Vue({
            el: '#blog-posts-events-demo',
            data: {
                posts: [
                    { id: 1, title: 'Giới thiệu về Vue to template' },
                    { id: 2, title: 'Các khái niệm trong Vue to template' },
                    { id: 3, title: 'Vue căn bản và vô cùng nâng cao to template' }
                ],
                postFontSize: 1
            }
        })

    </script>

    <!-- search input -->
    <custom-input v-bind:value="searchText" v-on:input="searchText = $event"></custom-input>
    <br>
    <!-- push component messager error -->
    <alert-box>
        Đã xảy ra cái gì gì đó.
    </alert-box>
    <script>
        Vue.component('custom-input', {
            props: ['value'],
            template: `<input v-bind:value="value" v-on:input="$emit('input', $event.target.value)>`
        })

        Vue.component('alert-box', {
            template: `
    <div class="demo-alert-box">
      <strong>Lỗi!</strong>
      <slot></slot>
    </div>
  `
        })
    </script>

    <br>

    <!-- register -->
    <script>
        var ComponentA = { /* ... */ }
        var ComponentB = { /* ... */ }
        var ComponentC = { /* ... */ }

    </script>
    <script>
        new Vue({
            el: '#app',
            components: {
                'component-a': ComponentA,
                'component-b': ComponentB,
                'component-c': ComponentC,
            }
        })
    </script>

    <!-- Prop Casing -->
    <blog-post post-title="hello!">Post Title</blog-post>
    <script>
        Vue.component('blog-post', {
            // camelCase in JavaScript
            props: ['postTitle'],
            template: '<h3>{{ postTitle }}</h3>'
        })
    </script>
    <blog-post title="My journey with Vue"></blog-post> <br>
    <blog-post v-bind:title="post.title"></blog-post> <br>
    <!-- # Passing a Number -->
    <!-- Even though `42` is static, we need v-bind to tell Vue that -->
    <!-- this is a JavaScript expression rather than a string.       -->
    <blog-post v-bind:likes="42"></blog-post>

    <!-- Dynamically assign to the value of a variable. -->
    <blog-post v-bind:likes="post.likes"></blog-post>
    <!-- arrayu -->
    <blog-post v-bind:comment-ids="[234, 266, 273]"></blog-post>

    <!-- Dynamically assign to the value of a variable. -->
    <blog-post v-bind:comment-ids="post.commentIds"></blog-post>

    <!-- object -->
    <blog-post v-bind:comments="{ id: 1, title: 'My Journey with Vue' }"></blog-post>

    <!-- Dynamically assign to the value of a variable. -->
    <blog-post v-bind:post="post"></blog-post>
</body>

</html>